// functions.js version 1.0
//
// This file is part of
// Connection Muse Version 1.0
// 
// Copyright (C) 2000-2005 Jean-Hugues Rety and Robert Kendall
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published 
// by the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Connection Muse provides javascript tools for 
// hypertext literary writing in html.
//
// Documentation: http://www.wordcircuits.com/connect
//
// e-mail: kendall@wordcircuits.com
//
// You can freely use and distribute this file provided that 
// this notice remains included. 
//
// ----------------------------------------------------
//
// Convert carriage returns and quote marks in "str"
// to their escape character equivalents; (note:
// carriage returns must be escaped differently for
// Windows, Mac, and Unix)
function makeSafeString(str) {
	str = str.replace(/"/g, "\\\"")
	str = str.replace(/\r\n/g, "\\n")
	str = str.replace(/\r/g, "\\n")
	str = str.replace(/\n/g, "\\n")
	return str
}

// Replace commas or spaces in list with '", "'
// If list contains ".htm" treat it as filename(s)
// and enclose in quotes
function parseList(list) {
	list = list.replace(/  /g, " ")
	list = list.replace(/, /g, ",")
	list = list.replace(/,/g, " ")
	list = list.replace(/ /g, '\", \"')
	if (list.indexOf(".htm") != -1) {
		list = "\"" + list + "\""
	}
	return list
}

// Get data from condition form fields and create
// first part of comment text
function getConditionData() {
	if (document.forms[0].condButton[0].checked) {
		cond = document.forms[0].condField.value
		condComment = cond
	}
	if (document.forms[0].condButton[1].checked) {
		var lastNode = document.forms[0].lastNodeField.value
		cond = 'hist(-1) == "' + lastNode + '"'
		condComment = 'last node visited was "' + lastNode + '"'
	}
	if (document.forms[0].condButton[2].checked) {
		var visitedNodes = document.forms[0].visitedNodesField.value
		// Get value from drop-down menu (visited/not visited)
		var i = document.forms[0].visitedNodesMenu.selectedIndex
		visitedNodes = parseList(visitedNodes)
		// Insert "!" ("not" operator) if appropriate
		cond = document.forms[0].visitedNodesMenu.options[i].value
		cond += "allVisited(" + visitedNodes + ")"
		visitedNodes = visitedNodes.replace(/\", \"/g, " & ")
		condComment = visitedNodes + " " + document.forms[0].visitedNodesMenu.options[i].text
		condComment += " previously been visited"
	}
	if (document.forms[0].condButton[3].checked) {
		cond = "nbVisits(hist(0)) > 1"
		condComment = "this node has previously been visited"
	}
}